/*
Scrivere un programma per la gestione delle automobili e dei noleggi.
Le automobili sono caratterizzate dalle seguenti informazioni: targa, anno di immatricolazione, chilometri percorsi, classe (0..3). 
I noleggi sono caratterizzati dalle seguenti informazioni: targa, codice fiscale del richiedente, giorno noleggio,  tipo di tariffa (0=ordinaria, 1=weekend, 2=WEB).
Le automobili sono inserite in un vettore di 4 liste, una per ogni classe. Le liste sono ordinate rispetto ai chilometri.
I noleggi sono  inseriti in una tabella allocata dinamicamente avente 3 righe, una  per ogni tipo di tariffa. 

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento ordinato nel vettore di liste di una nuova automobile; 
2.	Visualizzazione delle automobili appartenenti a una certa classe;
3.	Inserimento di un nuovo noleggio;
4.	Visualizzazione dei noleggi di un certo giorno;
5.	Eliminazione di un noleggio.

Liberare la memoria allocata dinamicamente.


*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct {
        char targa[10];
        int anno, chilometri, classe;
        } automobile;

typedef struct {
        char targa[10], giorno[12], codice[17];
        int tipo;
        } noleggio;
        
struct atomo {
       automobile dato;
       struct atomo *next;
       };
       
void leggi_auto(automobile *p);
void in_lista(struct atomo *VL[4]);
void visualizza_auto(struct atomo *VL[4]);
void leggi_noleggio(noleggio *n);
void inserisci_noleggio(noleggio *TB[3], int *N);
void visualizza(noleggio *TB[3], int *N);
void elimina(noleggio *TB[3], int *N);

main()
{
      int i, op, N[3];
      struct atomo *VL[4], *a;
      noleggio *TB[3];
      
      
      for(i=0;i<3;i++)
        {  TB[i]=NULL;
           N[i]=0;
           }
      
      for(i=0;i<4;i++)
      {    VL[i]=NULL;
      }
      
      do {
          printf("\n\nScegli fra:\n");
          printf(" 1) Inserisci automobile\n 2) Visualizza automobili\n 3) Inserisci noleggio\n");
          printf(" 4) Visualizza noleggio\n 5) Elimina noleggio\n 0) Fine\n\n");
          scanf("%d",&op);
          switch(op)
          { case 1: in_lista(VL);
                    break;
            case 2: visualizza_auto(VL);
                    break;
            case 3: inserisci_noleggio(TB,N);
                   break;
            case 4: visualizza(TB,N);
                    break;
			case 5: elimina(TB,N);
					break;
            default: ;
            }} while(op);
            
            
            for(i=0;i<4;i++)
               while(VL[i])
                  { a=VL[i];
                    VL[i]=a->next;
                 free(a);
                 }
               
            for(i=0;i<3;i++)
                  free(TB[i]);
                  
}
                 

void leggi_auto(automobile *p)
{
     printf("Targa: "); 
	 scanf("%s", p->targa);
     printf("Anno di immatricolazione: "); 
	 scanf("%d", &p->anno);
     printf("Chilometri percorsi: "); 
	 scanf("%d", &p->chilometri);
     printf("Classe di appartenenza (0..3): "); 
	 scanf("%d", &p->classe);
}
void in_lista(struct atomo *VL[4])
{
     struct atomo *a,*l1,*l2;
     automobile p;
     
     leggi_auto(&p);
     
     a=malloc(sizeof(struct atomo));
     
     if(a==NULL) return;
     a->dato=p;

	 if(VL[p.classe]==NULL || p.chilometri < VL[p.classe]->dato.chilometri)
	 { 
        a->next=VL[p.classe];
        VL[p.classe]=a;
		return;
	 }
	 l2=VL[p.classe];
	 l1=l2->next;
	 while(l1)
		 if(p.chilometri<l1->dato.chilometri)
			 break;
		 else 
		 { l2=l1;
			l1=l1->next;
	     }
	 l2->next=a;
	 a->next=l1;

}
void visualizza_auto(struct atomo *VL[4])
{
     struct atomo *l;
     int p;
    
     
     printf("Classe automobile (0..3) ");
     scanf("%d",&p);
     
     if(VL[p]==NULL)
     { printf("Nessuna automobile in questa categoria");
        return;
     }
	 l=VL[p];
     while(l)
	 {   printf("Anno di immatricolazione: %d\n", l->dato.anno);
         printf("Chilometri percorsi: %d\n\n", l->dato.chilometri);
         l=l->next;
     }
           
}

void leggi_noleggio(noleggio *n)
{
        printf("Targa: "); 
		scanf("%s",n->targa);
        printf("Giorno : "); 
		scanf("%s", n->giorno);
        printf("Codice fiscale cliente: "); 
		scanf("%s", n->codice);
        printf("Tipo di tariffa (0=ordinaria, 1=weekend, 2= WEB"); 
		scanf("%d", &n->tipo);

     }
void inserisci_noleggio(noleggio *TB[3], int *N)
{
     noleggio n, *a;
     
     leggi_noleggio(&n);
     a=realloc(TB[n.tipo],sizeof(noleggio)*(N[n.tipo]+1));
     if(a==NULL) return;
     
     TB[n.tipo]=a;
     TB[n.tipo][N[n.tipo]]=n;
     N[n.tipo]++;
     }

void visualizza(noleggio *TB[3], int *N)
{
     int p, i;
     
     printf("Tipo di noleggio da visualizzare: ");
     scanf("%d",&p);
     for(i=0;i<N[p];i++)
     {   printf("Targa: %s\n", TB[p][i].targa);
         printf("Codice fiscale: %s\n", TB[p][i].codice);
         printf("Giorno inizio noleggio: %s\n\n", TB[p][i].giorno);
         }
}

void elimina(noleggio *TB[3], int *N)
{
	int p,i,t;
	char targa[10];

     printf("Tipo di noleggio: ");
     scanf("%d",&p);
	 printf("Targa automobile: ");
	 scanf("%s",targa);
	 for(t=0;t<N[p];t++)
		if(strcmp(targa,TB[p][t].targa)==0)
			break;
	 if(t==N[p])
	  {	 printf("\nNon trovato\n");
		return;
	  }
     /* trovato*/
	 for(i=t;i<N[p]-1;i++)
		 TB[p][i]=TB[p][i+1];
   
      N[p]--;
	  TB[p]=realloc(TB[p],sizeof(noleggio)*N[p]);
}